package com.ejie.ab61.adaptadores;

import java.io.InputStream;

import com.ejie.ab61.exceptions.T65bDokusiException;

/**
 *  
 * 
 */
public interface T65BDokusiAdaptadorService {

	/**
	 * M�todo que descarga un documento en DOKUSI
	 * 
	 * @param documentID
	 *            String
	 * 
	 * @return InputStream
	 * 
	 * @throws T65bDokusiException
	 *             T65bDokusiException
	 */
	public InputStream retrieveDocument(String documentID) throws Exception;

	/**
	 * Método que descarga un documento de DOKUSI
	 * 
	 * @param documentID
	 *            oid del documento
	 * 
	 * @return String path del pif
	 * 
	 * @throws T65bDokusiException
	 *             T65bDokusiException
	 */
	public String retrieveDocumentR02G(String documentID) throws Exception;

	/**
	 * Método que descarga un documento de DOKUSI
	 * 
	 * @param oidDokusi
	 *            oid del documento
	 * @param aplicacion
	 *            aplicación que llama al método
	 * @return String path del pif
	 * @throws T65bDokusiException
	 *             T65bDokusiException
	 */
	public String retrieveDocumentAplicacion(String oidDokusi, String aplicacion) throws Exception;

}
