/**
 * 
 */
package com.ejie.ab61.adaptadores;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab61.clientesWS.X43CuentasInteresados.TInteresado;
import com.ejie.ab61.clientesWS.X43CuentasInteresados.TInterestedSearch;
import com.ejie.ab61.exceptions.X43CuentasInteresadosException;

/**
 *  
 * 
 */
@Service(value = "X43CuentasInteresadosAdaptadorServiceImpl")
public class X43CuentasInteresadosAdaptadorServiceImpl implements X43CuentasInteresadosAdaptadorService {

	public static final Logger logger = LoggerFactory.getLogger(X43CuentasInteresadosAdaptadorServiceImpl.class);

	@Autowired()
	private com.ejie.ab61.adaptadores.service.X43CuentasInteresadosService X43CuentasInteresadosService;

	/**
	 * Metodo que permite a la administración iniciar una solicitud bien por
	 * iniciativa propia, por ser una petición razonada o por una denuncia
	 * 
	 * @param adminInitiation
	 *            TAdminInitRequest
	 * @param ep
	 *            AExtensionPoint
	 * 
	 * @return TSubmissionResponse
	 * 
	 * @throws X43CuentasInteresadosException
	 *             X43CuentasInteresadosException
	 */
	public List<TInteresado> getPersonsConsent(TInterestedSearch tInterestedSearch)
			throws X43CuentasInteresadosException, Exception {

		X43CuentasInteresadosAdaptadorServiceImpl.logger
				.info("X43CuentasInteresadosAdaptadorServiceImpl.getPersonsConsent - Inicio");

		List<TInteresado> respuesta = this.X43CuentasInteresadosService.getPersonsConsent(tInterestedSearch);
		X43CuentasInteresadosAdaptadorServiceImpl.logger
				.info("X43CuentasInteresadosAdaptadorServiceImpl.getPersonsConsent - Return: " + respuesta);
		return respuesta;

	}

}
