/**
 * 
 */
package com.ejie.ab61.adaptadores;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ejie.ab61.adaptadores.service.X43ToolkitService;
import com.ejie.ab61.clientesWS.X43Toolkit.Exception_Exception;

/**
 *  
 * 
 */
@Service(value = "X43ToolkitAdapterServiceImpl")
public class X43ToolkitAdaptadorServiceImpl implements X43ToolkitAdaptadorService {

	public static final Logger logger = LoggerFactory.getLogger(X43ToolkitAdaptadorServiceImpl.class);

	@Autowired()
	private X43ToolkitService x43ToolkitService;

	/**
	 * Metodo que recupera el ejgvDocumento de la solicitud
	 * 
	 * @param idSolicitud
	 *            id del documento
	 * @param folderID
	 *            id del expediente
	 * 
	 * @return String: ejgvDocument Solicitud
	 * 
	 * @throws X43ToolkitException
	 *             X43ToolkitException
	 * @throws Exception_Exception
	 *             Exception_Exception
	 */
	public String getRequestInformation(String idSolicitud, String folderID) throws Exception_Exception {

		X43ToolkitAdaptadorServiceImpl.logger.info("X43ToolkitAdapterServiceImpl.getRequestInformation - Inicio");

		String respuesta = this.x43ToolkitService.getRequestInformation(idSolicitud, folderID);
		X43ToolkitAdaptadorServiceImpl.logger
				.info("X43ToolkitAdapterServiceImpl.getRequestInformation - Return: " + respuesta);
		return respuesta;

	}

}
