/**
 * 
 */
package com.ejie.ab61.adaptadores.service;

/**
 *  
 * 
 */
public interface T65BDokusiService {

	/**
	 * Método que descarga un documento en DOKUSI
	 * 
	 * @param tokenSesion
	 *            token de sesion
	 * @param auditUser
	 *            usuario
	 * @param documentID
	 *            id del documento
	 * @param keysList
	 *            lista de metadatos a devolver
	 * @param content
	 *            bean con la extension del documento a recuperar
	 * @return String: OID del documento. null si casca
	 * @throws Exception
	 *             ex
	 */
	public String retrieveDocument(String tokenSesion, String auditUser, String documentID, String keysList,
			String content) throws Exception;

	/**
	 * 
	 * @param integrationToken
	 *            String
	 * @param auditUser
	 *            String
	 * @param content
	 *            String
	 * @param documentalType
	 *            String
	 * @param attributeList
	 *            String
	 * @return String
	 * @throws Exception
	 *             exception
	 */
	public String storeDocument(String integrationToken, String auditUser, String content, String documentalType,
			String attributeList) throws Exception;

	/**
	 * Metodo que a�ade un localizador a un documento
	 * 
	 * @param integrationToken
	 *            String
	 * @param auditUser
	 *            String
	 * @param documentID
	 *            String
	 * @param boolVersion
	 *            boolean
	 * @param boolReducir
	 *            String
	 * @param sede
	 *            String
	 * @return String
	 * @throws Exception
	 *             exception
	 */

	public String addLocatorToDocumentQR(String integrationToken, String auditUser, String documentID,
			boolean boolVersion, String boolReducir, String sede) throws Exception;

}
