package com.ejie.ab61.dao;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab61.model.VTInsSinExpediente;

/**
 * VTInsSinExpedienteDao  
 * 
 *  
 */

public interface VTInsSinExpedienteDao {

	/**
	 * Inserts a single row in the VTInsSinExpediente table.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @return VTInsSinExpediente
	 */
	VTInsSinExpediente add(VTInsSinExpediente vtinssinexpediente);

	/**
	 * Updates a single row in the VTInsSinExpediente table.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @return VTInsSinExpediente
	 */
	VTInsSinExpediente update(VTInsSinExpediente vtinssinexpediente);

	/**
	 * Finds a single row in the VTInsSinExpediente table.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @return VTInsSinExpediente
	 */
	VTInsSinExpediente find(VTInsSinExpediente vtinssinexpediente);

	/**
	 * Removes a single row in the VTInsSinExpediente table.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 */
	void remove(VTInsSinExpediente vtinssinexpediente);

	/**
	 * Finds a List of rows in the VTInsSinExpediente table.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<VTInsSinExpediente> findAll(VTInsSinExpediente vtinssinexpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the VTInsSinExpediente table using like.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<VTInsSinExpediente> findAllLike(VTInsSinExpediente vtinssinexpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(VTInsSinExpediente filterVTInsSinExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Counts rows in the VTInsSinExpediente table using like.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(VTInsSinExpediente vtinssinexpediente, Boolean startsWith);

	/**
	 * Counts rows in the VTInsSinExpediente table.
	 *
	 * @param vtinssinexpediente
	 *            VTInsSinExpediente
	 * @return Long
	 */
	Long findAllCount(VTInsSinExpediente vtinssinexpediente);

	/**
	 * Reorder selection.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VTInsSinExpediente>>
	 */
	List<TableRowDto<VTInsSinExpediente>> reorderSelection(VTInsSinExpediente filterVTInsSinExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param searchVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VTInsSinExpediente>>
	 */
	List<TableRowDto<VTInsSinExpediente>> search(VTInsSinExpediente filterVTInsSinExpediente,
			VTInsSinExpediente searchVTInsSinExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<VTInsSinExpediente>>
	 */
	List<JerarquiaDto<VTInsSinExpediente>> findAllLikeJerarquia(VTInsSinExpediente filterVTInsSinExpediente,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(VTInsSinExpediente filterVTInsSinExpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<VTInsSinExpediente>>
	 */
	List<TableRowDto<VTInsSinExpediente>> findAllChild(VTInsSinExpediente filterVTInsSinExpediente,
			JQGridRequestDto jqGridRequestDto);

	List<VTInsSinExpediente> findInspeccionesARelacionar(VTInsSinExpediente filterVTInsSinExpediente,
			Integer idExpediente, JQGridRequestDto jqGridRequestDto, String documentosTitular, boolean startsWith);

	Long findInspeccionesARelacionarCount(VTInsSinExpediente filterVTInsSinExpediente, String documentosTitular,
			Integer idExpediente, boolean startsWith);

}
