package com.ejie.ab61.dao.busquedas;

import java.util.List;

import com.ejie.ab61.model.busquedas.Busquedas;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ListadosDao  
 * 
 *  
 */

public interface BusquedasDao {

	/**
	 * Inserts a single row in the Listados table.
	 *
	 * @param listados
	 *            Listados
	 * @return Listados
	 */
	Busquedas add(Busquedas busquedas);

	//
	/**
	 * Updates a single row in the Busquedas table.
	 *
	 * @param busquedas
	 *            Busquedas
	 * @return Busquedas
	 */
	Busquedas update(Busquedas busquedas);

	/**
	 * Finds a single row in the Busquedas table.
	 *
	 * @param busquedas
	 *            Busquedas
	 * @return Busquedas
	 */
	Busquedas find(Busquedas busquedas);

	/**
	 * Removes a single row in the Busquedas table.
	 *
	 * @param busquedas
	 *            Busquedas
	 */
	void remove(Busquedas busquedas);
	//
	// /**
	// * Finds a List of rows in the Listados table.
	// *
	// * @param listados
	// * Listados
	// * @param jqGridRequestDto
	// * JQGridRequestDto
	// * @return List
	// */
	// List<Listados> findAll(Listados listados, JQGridRequestDto
	// jqGridRequestDto);

	/**
	 * Finds rows in the Listados table using like.
	 *
	 * @param listados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Busquedas> findAllLike(Busquedas busquedas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the Listados table using like.
	 *
	 * @param listados
	 *            Listados
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Busquedas busquedas, Boolean startsWith);

	// /**
	// * Counts rows in the Listados table.
	// *
	// * @param listados
	// * Listados
	// * @return Long
	// */
	// Long findAllCount(Listados listados);

	/**
	 * Reorder selection.
	 *
	 * @param filterListados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Listados>>
	 */
	List<TableRowDto<Busquedas>> reorderSelection(Busquedas filterBusquedas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);
}
