package com.ejie.ab61.dao.nora;

import java.util.List;

import com.ejie.ab61.model.nora.T17Pais;

/**
 * T17PaisDao  
 */

import com.ejie.x38.dto.Pagination;

/**
 * T17PaisDao  
 * 
 *  
 */
public interface T17PaisDao {
	/**
	 * Inserts a single row in the T17Pais table.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * @return T17Pais
	 */
	T17Pais add(T17Pais t17pais);

	/**
	 * Updates a single row in the T17Pais table.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * @return T17Pais
	 */
	T17Pais update(T17Pais t17pais);

	/**
	 * Finds a single row in the T17Pais table.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * @return T17Pais
	 */
	T17Pais find(T17Pais t17pais);

	/**
	 * Deletes a single row in the T17Pais table.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * 
	 */
	void remove(T17Pais t17pais);

	/**
	 * Finds a List of rows in the T17Pais table.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * @param pagination
	 *            Pagination<Object>
	 * 
	 * @return List<T17Pais>
	 */
	List<T17Pais> findAll(T17Pais t17pais, Pagination<Object> pagination);

	/**
	 * Counts rows in the T17Pais table.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * @return Long
	 */
	Long findAllCount(T17Pais t17pais);

	/**
	 * Finds rows in the T17Pais table using like.
	 * 
	 * @param t17pais
	 *            T17Pais
	 * @param pagination
	 *            Pagination<Object>
	 * @param startsWith
	 *            Boolean
	 * 
	 * @return List<T17Pais>
	 */
	List<T17Pais> findAllLike(T17Pais t17pais, Pagination<Object> pagination, Boolean startsWith);
}
