package com.ejie.ab61.dao.plantillas;

import com.ejie.ab61.model.plantillas.RelTipPlaPro;
import com.ejie.ab61.model.plantillas.TiposPlantilla;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelTipPlaProDao  
 * 
 *  
 */

public interface RelTipPlaProDao {

	/**
	 * Inserts a single row in the RelTipPlaPro table.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @return RelTipPlaPro
	 */
	RelTipPlaPro add(RelTipPlaPro reltipplapro);

	/**
	 * Updates a single row in the RelTipPlaPro table.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @return RelTipPlaPro
	 */
	RelTipPlaPro update(RelTipPlaPro reltipplapro);

	/**
	 * Finds a single row in the RelTipPlaPro table.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @return RelTipPlaPro
	 */
	RelTipPlaPro find(RelTipPlaPro reltipplapro);

	/**
	 * Removes a single row in the RelTipPlaPro table.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 */
	void remove(RelTipPlaPro reltipplapro);

	/**
	 * Finds a List of rows in the RelTipPlaPro table.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<RelTipPlaPro> findAll(RelTipPlaPro reltipplapro, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelTipPlaPro table using like.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<RelTipPlaPro> findAllLike(RelTipPlaPro reltipplapro, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the RelTipPlaPro table using like.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(RelTipPlaPro reltipplapro, Boolean startsWith);

	/**
	 * Counts rows in the RelTipPlaPro table.
	 *
	 * @param reltipplapro
	 *            RelTipPlaPro
	 * @return Long
	 */
	Long findAllCount(RelTipPlaPro reltipplapro);

	/**
	 * Reorder selection.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipPlaPro>>
	 */
	List<TableRowDto<RelTipPlaPro>> reorderSelection(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param searchRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipPlaPro>>
	 */
	List<TableRowDto<RelTipPlaPro>> search(RelTipPlaPro filterRelTipPlaPro, RelTipPlaPro searchRelTipPlaPro,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<RelTipPlaPro>>
	 */
	List<JerarquiaDto<RelTipPlaPro>> findAllLikeJerarquia(RelTipPlaPro filterRelTipPlaPro,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<RelTipPlaPro>>
	 */
	List<TableRowDto<RelTipPlaPro>> findAllChild(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto);

	List<RelTipPlaPro> findByTipoPlantilla(TiposPlantilla tipoPlantilla);

	void removeByTipoPlantilla(TiposPlantilla tiposPlantilla);

}
