package com.ejie.ab61.dao.procedimientos;

import java.util.List;

import com.ejie.ab61.model.procedimientos.Aplicaciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AplicacionesDao  
 * 
 *  
 */

public interface AplicacionesDao {

	/**
	 * Inserts a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Aplicaciones
	 */
	Aplicaciones add(Aplicaciones aplicaciones);

	/**
	 * Updates a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Aplicaciones
	 */
	Aplicaciones update(Aplicaciones aplicaciones);

	/**
	 * Finds a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Aplicaciones
	 */
	Aplicaciones find(Aplicaciones aplicaciones);

	/**
	 * Removes a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 */
	void remove(Aplicaciones aplicaciones);

	/**
	 * Finds a List of rows in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List
	 */
	List<Aplicaciones> findAll(Aplicaciones aplicaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Aplicaciones table using like.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Aplicaciones> findAllLike(Aplicaciones aplicaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Aplicaciones table using like.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Aplicaciones aplicaciones, Boolean startsWith);

	/**
	 * Counts rows in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Long
	 */
	Long findAllCount(Aplicaciones aplicaciones);

	/**
	 * Reorder selection.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Aplicaciones>>
	 */
	List<TableRowDto<Aplicaciones>> reorderSelection(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param searchAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Aplicaciones>>
	 */
	List<TableRowDto<Aplicaciones>> search(Aplicaciones filterAplicaciones, Aplicaciones searchAplicaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<JerarquiaDto<Aplicaciones>>
	 */
	List<JerarquiaDto<Aplicaciones>> findAllLikeJerarquia(Aplicaciones filterAplicaciones,
			JQGridRequestDto jqGridRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<TableRowDto<Aplicaciones>>
	 */
	List<TableRowDto<Aplicaciones>> findAllChild(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto);

}
