package com.ejie.ab61.dao.procedimientos;

import com.ejie.ab61.model.procedimientos.Direcciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DireccionesDao  
 *  
 */

public interface DireccionesDao {
    
    /**
     * Inserts a single row in the Direcciones table.
     *
     * @param direcciones Direcciones
     * @return Direcciones
     */
    Direcciones add(Direcciones direcciones);

    /**
     * Updates a single row in the Direcciones table.
     *
     * @param direcciones Direcciones
     * @return Direcciones
     */
    Direcciones update(Direcciones direcciones);

    /**
     * Finds a single row in the Direcciones table.
     *
     * @param direcciones Direcciones
     * @return Direcciones
     */
    Direcciones find(Direcciones direcciones);

    /**
     * Removes a single row in the Direcciones table.
     *
     * @param direcciones Direcciones
     */
    void remove(Direcciones direcciones);

    /**
     * Finds a List of rows in the Direcciones table.
     *
     * @param direcciones Direcciones
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<Direcciones> findAll(Direcciones direcciones, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the Direcciones table using like.
     *
     * @param direcciones Direcciones
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<Direcciones> findAllLike(Direcciones direcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the Direcciones table using like.
     *
     * @param direcciones Direcciones
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(Direcciones direcciones, Boolean startsWith);
    
    /**
     * Counts rows in the Direcciones table.
     *
     * @param direcciones Direcciones
     * @return Long
     */
    Long findAllCount(Direcciones direcciones);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Direcciones>>
	 */	
    List<TableRowDto<Direcciones>> reorderSelection(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param searchDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Direcciones>>	 
	 */	
    List<TableRowDto<Direcciones>> search(Direcciones filterDirecciones, Direcciones searchDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<Direcciones>>
	 */	
	List<JerarquiaDto<Direcciones>> findAllLikeJerarquia(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<Direcciones>>
	 */	
	List<TableRowDto<Direcciones>> findAllChild(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto);
	
	
}

