package com.ejie.ab61.dao.solicitudes;

import com.ejie.ab61.model.solicitudes.MensajesSolicitud;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * MensajesSolicitudDao  
 *  
 */

public interface MensajesSolicitudDao {
    
    /**
     * Inserts a single row in the MensajesSolicitud table.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @return MensajesSolicitud
     */
    MensajesSolicitud add(MensajesSolicitud mensajessolicitud);

    /**
     * Updates a single row in the MensajesSolicitud table.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @return MensajesSolicitud
     */
    MensajesSolicitud update(MensajesSolicitud mensajessolicitud);

    /**
     * Finds a single row in the MensajesSolicitud table.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @return MensajesSolicitud
     */
    MensajesSolicitud find(MensajesSolicitud mensajessolicitud);

    /**
     * Removes a single row in the MensajesSolicitud table.
     *
     * @param mensajessolicitud MensajesSolicitud
     */
    void remove(MensajesSolicitud mensajessolicitud);

    /**
     * Finds a List of rows in the MensajesSolicitud table.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @param jqGridRequestDto JQGridRequestDto
     * @return List
     */
    List<MensajesSolicitud> findAll(MensajesSolicitud mensajessolicitud, JQGridRequestDto jqGridRequestDto);

	/**
     * Finds rows in the MensajesSolicitud table using like.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean
     * @return List
     */
	List<MensajesSolicitud> findAllLike(MensajesSolicitud mensajessolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Filter in the MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	 void removeMultiple(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	
    /**
     * Counts rows in the MensajesSolicitud table using like.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @param startsWith Boolean
     * @return Long
     */
    Long findAllLikeCount(MensajesSolicitud mensajessolicitud, Boolean startsWith);
    
    /**
     * Counts rows in the MensajesSolicitud table.
     *
     * @param mensajessolicitud MensajesSolicitud
     * @return Long
     */
    Long findAllCount(MensajesSolicitud mensajessolicitud);
    
    /**
	 * Reorder selection.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<MensajesSolicitud>>
	 */	
    List<TableRowDto<MensajesSolicitud>> reorderSelection(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
     /**
	 * Searches in the Usuario table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param searchMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<MensajesSolicitud>>	 
	 */	
    List<TableRowDto<MensajesSolicitud>> search(MensajesSolicitud filterMensajesSolicitud, MensajesSolicitud searchMensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
    
    /**
	 * Filter in the hierarchical MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<JerarquiaDto<MensajesSolicitud>>
	 */	
	List<JerarquiaDto<MensajesSolicitud>> findAllLikeJerarquia(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Count rows in hierarchy
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return Long
	 */	
	Long findAllLikeCountJerarquia(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto);
	
	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TableRowDto<MensajesSolicitud>>
	 */	
	List<TableRowDto<MensajesSolicitud>> findAllChild(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto);
	
	
}

