package com.ejie.ab61.service;

import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

import com.ejie.ab61.model.VTInsSinExpediente;

/**
 * VTInsSinExpedienteService  
 * 
 *  
 */

public interface VTInsSinExpedienteService {

	/**
	 * Inserts a single row in the VTInsSinExpediente table.
	 *
	 * @param vTInsSinExpediente
	 *            VTInsSinExpediente
	 * @return VTInsSinExpediente
	 */
	VTInsSinExpediente add(VTInsSinExpediente vTInsSinExpediente);

	/**
	 * Updates a single row in the VTInsSinExpediente table.
	 *
	 * @param vTInsSinExpediente
	 *            VTInsSinExpediente
	 * @return VTInsSinExpediente
	 */
	VTInsSinExpediente update(VTInsSinExpediente vTInsSinExpediente);

	/**
	 * Finds a single row in the VTInsSinExpediente table.
	 *
	 * @param vTInsSinExpediente
	 *            VTInsSinExpediente
	 * @return VTInsSinExpediente
	 */
	VTInsSinExpediente find(VTInsSinExpediente vTInsSinExpediente);

	/**
	 * Deletes a single row in the VTInsSinExpediente table.
	 *
	 * @param vTInsSinExpediente
	 *            VTInsSinExpediente
	 */
	void remove(VTInsSinExpediente vTInsSinExpediente);

	/**
	 * Finds a list of rows in the VTInsSinExpediente table.
	 *
	 * @param vTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<VTInsSinExpediente>
	 */
	List<VTInsSinExpediente> findAll(VTInsSinExpediente vTInsSinExpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the VTInsSinExpediente table using like.
	 *
	 * @param vTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<VTInsSinExpediente>
	 */
	List<VTInsSinExpediente> findAllLike(VTInsSinExpediente vTInsSinExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(VTInsSinExpediente filterVTInsSinExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Filter method in the VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<VTInsSinExpediente>
	 */
	JQGridResponseDto<VTInsSinExpediente> filter(VTInsSinExpediente filterVTInsSinExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param searchVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<VTInsSinExpediente>>
	 */
	List<TableRowDto<VTInsSinExpediente>> search(VTInsSinExpediente filterVTInsSinExpediente,
			VTInsSinExpediente searchVTInsSinExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(VTInsSinExpediente filterVTInsSinExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<VTInsSinExpediente>>
	 */
	JQGridResponseDto<JerarquiaDto<VTInsSinExpediente>> jerarquia(VTInsSinExpediente filterVTInsSinExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the
	 * VTInsSinExpediente table.
	 *
	 * @param filterVTInsSinExpediente
	 *            VTInsSinExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<VTInsSinExpediente>>
	 */
	JQGridResponseDto<JerarquiaDto<VTInsSinExpediente>> jerarquiaChildren(VTInsSinExpediente filterVTInsSinExpediente,
			JQGridRequestDto jqGridRequestDto);

	JQGridResponseDto<VTInsSinExpediente> filterInspeccionesARelacionar(VTInsSinExpediente filterVTInsSinExpediente,
			Integer idExpediente, JQGridRequestDto jqGridRequestDto, String documentosTitular, boolean startsWith);

}
