package com.ejie.ab61.service.busquedas;

import java.util.List;

import com.ejie.ab61.model.busquedas.Busquedas;
import com.ejie.ab61.model.listados.Listados;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;

/**
 * ListadosService  
 * 
 *  
 */

public interface BusquedasService {

	/**
	 * Inserts a single row in the Listados table.
	 *
	 * @param busquedas
	 *            Busquedas
	 * @return Busquedas
	 */
	Busquedas add(Busquedas busquedas);

	//
	/**
	 * Updates a single row in the Listados table.
	 *
	 * @param busquedas
	 *            Busquedas
	 * @return Busquedas
	 */
	Busquedas update(Busquedas busquedas);

	/**
	 * Finds a single row in the Busquedas table.
	 *
	 * @param busquedas
	 *            Busquedas
	 * @return Busquedas
	 */
	Busquedas find(Busquedas busquedas);

	/**
	 * Deletes a single row in the Busquedas table.
	 *
	 * @param busquedas
	 *            Busquedas
	 */
	void remove(Busquedas busquedas);

	// /**
	// * Finds a list of rows in the Listados table.
	// *
	// * @param listados
	// * Listados
	// * @param jqGridRequestDto
	// * JQGridRequestDto
	// * @return List<Listados>
	// */
	// List<Listados> findAll(Listados listados, JQGridRequestDto
	// jqGridRequestDto);

	/**
	 * Finds rows in the Listados table using like.
	 *
	 * @param filterBusquedas
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Listados>
	 */
	List<Busquedas> findAllLike(Busquedas filterBusquedas, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the Listados table.
	 *
	 * @param filterListados
	 *            Listados
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Listados>
	 */
	JQGridResponseDto<Busquedas> filter(Busquedas filterBusquedas, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);
}
