package com.ejie.ab61.service.documentosPid;

import com.ejie.ab61.model.documentosPid.DocumentosPid;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DocumentosPidService  
 * 
 *  
 */

public interface DocumentosPidService {

	/**
	 * Inserts a single row in the DocumentosPid table.
	 *
	 * @param documentosPid
	 *            DocumentosPid
	 * @return DocumentosPid
	 */
	DocumentosPid add(DocumentosPid documentosPid);

	/**
	 * Updates a single row in the DocumentosPid table.
	 *
	 * @param documentosPid
	 *            DocumentosPid
	 * @return DocumentosPid
	 */
	DocumentosPid update(DocumentosPid documentosPid);

	/**
	 * Finds a single row in the DocumentosPid table.
	 *
	 * @param documentosPid
	 *            DocumentosPid
	 * @return DocumentosPid
	 */
	DocumentosPid find(DocumentosPid documentosPid);

	/**
	 * Deletes a single row in the DocumentosPid table.
	 *
	 * @param documentosPid
	 *            DocumentosPid
	 */
	void remove(DocumentosPid documentosPid);

	/**
	 * Finds a list of rows in the DocumentosPid table.
	 *
	 * @param documentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DocumentosPid>
	 */
	List<DocumentosPid> findAll(DocumentosPid documentosPid, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the DocumentosPid table using like.
	 *
	 * @param documentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DocumentosPid>
	 */
	List<DocumentosPid> findAllLike(DocumentosPid documentosPid, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DocumentosPid table.
	 *
	 * @param filterDocumentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(DocumentosPid filterDocumentosPid, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the DocumentosPid table.
	 *
	 * @param filterDocumentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DocumentosPid>
	 */
	JQGridResponseDto<DocumentosPid> filter(DocumentosPid filterDocumentosPid, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the DocumentosPid table.
	 *
	 * @param filterDocumentosPid
	 *            DocumentosPid
	 * @param searchDocumentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DocumentosPid>>
	 */
	List<TableRowDto<DocumentosPid>> search(DocumentosPid filterDocumentosPid, DocumentosPid searchDocumentosPid,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in DocumentosPid table.
	 *
	 * @param filterDocumentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(DocumentosPid filterDocumentosPid, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DocumentosPid table.
	 *
	 * @param filterDocumentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DocumentosPid>>
	 */
	JQGridResponseDto<JerarquiaDto<DocumentosPid>> jerarquia(DocumentosPid filterDocumentosPid,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the DocumentosPid
	 * table.
	 *
	 * @param filterDocumentosPid
	 *            DocumentosPid
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DocumentosPid>>
	 */
	JQGridResponseDto<JerarquiaDto<DocumentosPid>> jerarquiaChildren(DocumentosPid filterDocumentosPid,
			JQGridRequestDto jqGridRequestDto);

	DocumentosPid findIdByOidPid(String oidPid);

	void removeByOidPid(String oidPid);

}
