package com.ejie.ab61.service.expedientes;

import java.util.List;

import com.ejie.ab61.model.expedientes.FechasExpediente;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * FechasExpedienteService  
 * 
 *  
 */

public interface FechasExpedienteService {

	/**
	 * Inserts a single row in the FechasExpediente table.
	 *
	 * @param fechasExpediente
	 *            FechasExpediente
	 * @return FechasExpediente
	 */
	FechasExpediente add(FechasExpediente fechasExpediente);

	/**
	 * Updates a single row in the FechasExpediente table.
	 *
	 * @param fechasExpediente
	 *            FechasExpediente
	 * @return FechasExpediente
	 */
	FechasExpediente update(FechasExpediente fechasExpediente);

	/**
	 * Finds a single row in the FechasExpediente table.
	 *
	 * @param fechasExpediente
	 *            FechasExpediente
	 * @return FechasExpediente
	 */
	FechasExpediente find(FechasExpediente fechasExpediente);

	/**
	 * Deletes a single row in the FechasExpediente table.
	 *
	 * @param fechasExpediente
	 *            FechasExpediente
	 */
	void remove(FechasExpediente fechasExpediente);

	/**
	 * Finds a list of rows in the FechasExpediente table.
	 *
	 * @param fechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<FechasExpediente>
	 */
	List<FechasExpediente> findAll(FechasExpediente fechasExpediente, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the FechasExpediente table using like.
	 *
	 * @param fechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<FechasExpediente>
	 */
	List<FechasExpediente> findAllLike(FechasExpediente fechasExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(FechasExpediente filterFechasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<FechasExpediente>
	 */
	JQGridResponseDto<FechasExpediente> filter(FechasExpediente filterFechasExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param searchFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<FechasExpediente>>
	 */
	List<TableRowDto<FechasExpediente>> search(FechasExpediente filterFechasExpediente,
			FechasExpediente searchFechasExpediente, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(FechasExpediente filterFechasExpediente, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the FechasExpediente table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<FechasExpediente>>
	 */
	JQGridResponseDto<JerarquiaDto<FechasExpediente>> jerarquia(FechasExpediente filterFechasExpediente,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the FechasExpediente
	 * table.
	 *
	 * @param filterFechasExpediente
	 *            FechasExpediente
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<FechasExpediente>>
	 */
	JQGridResponseDto<JerarquiaDto<FechasExpediente>> jerarquiaChildren(FechasExpediente filterFechasExpediente,
			JQGridRequestDto jqGridRequestDto);

}
