package com.ejie.ab61.service.inicioOficioExp;

import java.util.List;

import com.ejie.ab61.model.inicioOficioExp.RelExpOriDes;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelExpOriDesService  
 * 
 *  
 */

public interface RelExpOriDesService {

	/**
	 * Inserts a single row in the RelExpOriDes table.
	 *
	 * @param relExpOriDes
	 *            RelExpOriDes
	 * @return RelExpOriDes
	 */
	RelExpOriDes add(RelExpOriDes relExpOriDes);

	/**
	 * Updates a single row in the RelExpOriDes table.
	 *
	 * @param relExpOriDes
	 *            RelExpOriDes
	 * @return RelExpOriDes
	 */
	RelExpOriDes update(RelExpOriDes relExpOriDes);

	/**
	 * Finds a single row in the RelExpOriDes table.
	 *
	 * @param relExpOriDes
	 *            RelExpOriDes
	 * @return RelExpOriDes
	 */
	RelExpOriDes find(RelExpOriDes relExpOriDes);

	/**
	 * Deletes a single row in the RelExpOriDes table.
	 *
	 * @param relExpOriDes
	 *            RelExpOriDes
	 */
	void remove(RelExpOriDes relExpOriDes);

	/**
	 * Finds a list of rows in the RelExpOriDes table.
	 *
	 * @param relExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelExpOriDes>
	 */
	List<RelExpOriDes> findAll(RelExpOriDes relExpOriDes, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelExpOriDes table using like.
	 *
	 * @param relExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelExpOriDes>
	 */
	List<RelExpOriDes> findAllLike(RelExpOriDes relExpOriDes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelExpOriDes table.
	 *
	 * @param filterRelExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelExpOriDes filterRelExpOriDes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelExpOriDes table.
	 *
	 * @param filterRelExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelExpOriDes>
	 */
	JQGridResponseDto<RelExpOriDes> filter(RelExpOriDes filterRelExpOriDes, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelExpOriDes table.
	 *
	 * @param filterRelExpOriDes
	 *            RelExpOriDes
	 * @param searchRelExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelExpOriDes>>
	 */
	List<TableRowDto<RelExpOriDes>> search(RelExpOriDes filterRelExpOriDes, RelExpOriDes searchRelExpOriDes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelExpOriDes table.
	 *
	 * @param filterRelExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelExpOriDes filterRelExpOriDes, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelExpOriDes table.
	 *
	 * @param filterRelExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelExpOriDes>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpOriDes>> jerarquia(RelExpOriDes filterRelExpOriDes,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelExpOriDes
	 * table.
	 *
	 * @param filterRelExpOriDes
	 *            RelExpOriDes
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelExpOriDes>>
	 */
	JQGridResponseDto<JerarquiaDto<RelExpOriDes>> jerarquiaChildren(RelExpOriDes filterRelExpOriDes,
			JQGridRequestDto jqGridRequestDto);

}
