package com.ejie.ab61.service.mensajesError;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab61.dao.mensajesError.MensajesErrorDao;
import com.ejie.ab61.model.configuracionEventos.ConfigEventos;
import com.ejie.ab61.model.mensajesError.MensajesError;

@Service(value = "mensajesErrorService")
public class MensajesErrorServiceImpl implements MensajesErrorService {

	private static final Logger logger = LoggerFactory.getLogger(MensajesErrorServiceImpl.class);

	@Autowired
	private MensajesErrorDao mensajesErrorDao;

	/**
	 * Inserts a single row in the MensajesError table.
	 *
	 * @param mensajesError
	 *            MensajesError
	 * @return MensajesError
	 */
	@Transactional(rollbackFor = Throwable.class)
	public MensajesError add(MensajesError mensajesError) {
		return this.mensajesErrorDao.add(mensajesError);
	}

	/**
	 * Finds a single row in the MensajesError table.
	 *
	 * @param mensajesError
	 *            MensajesError
	 * @return MensajesError
	 */
	public MensajesError find(MensajesError mensajesError) {
		return (MensajesError) this.mensajesErrorDao.find(mensajesError);
	}

	/**
	 * Removes a single row in the MensajesError table.
	 *
	 * @param mensajesError
	 *            MensajesError
	 * @return
	 */
	public void remove(MensajesError mensajesError) {
		this.mensajesErrorDao.remove(mensajesError);
	}

}
