package com.ejie.ab61.service.plantillas;

import com.ejie.ab61.model.plantillas.RelTipPlaPro;
import com.ejie.ab61.model.plantillas.TiposPlantilla;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * RelTipPlaProService  
 * 
 *  
 */

public interface RelTipPlaProService {

	/**
	 * Inserts a single row in the RelTipPlaPro table.
	 *
	 * @param relTipPlaPro
	 *            RelTipPlaPro
	 * @return RelTipPlaPro
	 */
	RelTipPlaPro add(RelTipPlaPro relTipPlaPro);

	/**
	 * Updates a single row in the RelTipPlaPro table.
	 *
	 * @param relTipPlaPro
	 *            RelTipPlaPro
	 * @return RelTipPlaPro
	 */
	RelTipPlaPro update(RelTipPlaPro relTipPlaPro);

	/**
	 * Finds a single row in the RelTipPlaPro table.
	 *
	 * @param relTipPlaPro
	 *            RelTipPlaPro
	 * @return RelTipPlaPro
	 */
	RelTipPlaPro find(RelTipPlaPro relTipPlaPro);

	/**
	 * Deletes a single row in the RelTipPlaPro table.
	 *
	 * @param relTipPlaPro
	 *            RelTipPlaPro
	 */
	void remove(RelTipPlaPro relTipPlaPro);

	/**
	 * Finds a list of rows in the RelTipPlaPro table.
	 *
	 * @param relTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<RelTipPlaPro>
	 */
	List<RelTipPlaPro> findAll(RelTipPlaPro relTipPlaPro, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the RelTipPlaPro table using like.
	 *
	 * @param relTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RelTipPlaPro>
	 */
	List<RelTipPlaPro> findAllLike(RelTipPlaPro relTipPlaPro, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<RelTipPlaPro>
	 */
	JQGridResponseDto<RelTipPlaPro> filter(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param searchRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RelTipPlaPro>>
	 */
	List<TableRowDto<RelTipPlaPro>> search(RelTipPlaPro filterRelTipPlaPro, RelTipPlaPro searchRelTipPlaPro,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(RelTipPlaPro filterRelTipPlaPro, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the RelTipPlaPro table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<RelTipPlaPro>>
	 */
	JQGridResponseDto<JerarquiaDto<RelTipPlaPro>> jerarquia(RelTipPlaPro filterRelTipPlaPro,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the RelTipPlaPro
	 * table.
	 *
	 * @param filterRelTipPlaPro
	 *            RelTipPlaPro
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<RelTipPlaPro>>
	 */
	JQGridResponseDto<JerarquiaDto<RelTipPlaPro>> jerarquiaChildren(RelTipPlaPro filterRelTipPlaPro,
			JQGridRequestDto jqGridRequestDto);

	List<RelTipPlaPro> findByTipoPlantilla(TiposPlantilla tiposPlantilla);

	void removeByTipoPlantilla(TiposPlantilla tiposPlantilla);

}
