package com.ejie.ab61.service.procedimientos;

import java.util.List;

import com.ejie.ab61.model.procedimientos.Aplicaciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * AplicacionesService  
 * 
 *  
 */

public interface AplicacionesService {

	/**
	 * Inserts a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Aplicaciones
	 */
	Aplicaciones add(Aplicaciones aplicaciones);

	/**
	 * Updates a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Aplicaciones
	 */
	Aplicaciones update(Aplicaciones aplicaciones);

	/**
	 * Finds a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @return Aplicaciones
	 */
	Aplicaciones find(Aplicaciones aplicaciones);

	/**
	 * Deletes a single row in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 */
	void remove(Aplicaciones aplicaciones);

	/**
	 * Finds a list of rows in the Aplicaciones table.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<Aplicaciones>
	 */
	List<Aplicaciones> findAll(Aplicaciones aplicaciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Aplicaciones table using like.
	 *
	 * @param aplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Aplicaciones>
	 */
	List<Aplicaciones> findAllLike(Aplicaciones aplicaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<Aplicaciones>
	 */
	JQGridResponseDto<Aplicaciones> filter(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/**
	 * Searches rows in the Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param searchAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Aplicaciones>>
	 */
	List<TableRowDto<Aplicaciones>> search(Aplicaciones filterAplicaciones, Aplicaciones searchAplicaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(Aplicaciones filterAplicaciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Aplicaciones table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Aplicaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Aplicaciones>> jerarquia(Aplicaciones filterAplicaciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the Aplicaciones
	 * table.
	 *
	 * @param filterAplicaciones
	 *            Aplicaciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Aplicaciones>>
	 */
	JQGridResponseDto<JerarquiaDto<Aplicaciones>> jerarquiaChildren(Aplicaciones filterAplicaciones,
			JQGridRequestDto jqGridRequestDto);

}
