package com.ejie.ab61.service.procedimientos;


import com.ejie.ab61.model.procedimientos.Departamentos;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DepartamentosService  
 *  
 */

public interface DepartamentosService {

	/**
	 * Inserts a single row in the Departamentos table.
	 *
	 * @param departamentos Departamentos
	 * @return Departamentos
	 */
    Departamentos add(Departamentos departamentos);

	/**
	 * Updates a single row in the Departamentos table.
	 *
	 * @param departamentos Departamentos
	 * @return Departamentos
	 */
	Departamentos update(Departamentos departamentos);

	/**
	 * Finds a single row in the Departamentos table.
	 *
	 * @param departamentos Departamentos
	 * @return Departamentos
	 */
	Departamentos find(Departamentos departamentos);

	/**
	 * Deletes a single row in the Departamentos table.
	 *
	 * @param departamentos Departamentos
	 */
	void remove(Departamentos departamentos);

	/**
	 * Finds a list of rows in the Departamentos table.
	 *
	 * @param departamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<Departamentos>
	 */
	List<Departamentos> findAll(Departamentos departamentos, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Departamentos table using like.
	 *
	 * @param departamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<Departamentos>
	 */
	List<Departamentos> findAllLike(Departamentos departamentos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Departamentos table.
	 *
	 * @param filterDepartamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(Departamentos filterDepartamentos, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the Departamentos table.
	 *
	 * @param filterDepartamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<Departamentos>
	 */	
	JQGridResponseDto<Departamentos> filter(Departamentos filterDepartamentos, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the Departamentos table.
	 *
	 * @param filterDepartamentos Departamentos
	 * @param searchDepartamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Departamentos>>
	 */	
    List<TableRowDto<Departamentos>> search(Departamentos filterDepartamentos, Departamentos searchDepartamentos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in Departamentos table.
	 *
	 * @param filterDepartamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(Departamentos filterDepartamentos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the Departamentos table.
	 *
	 * @param filterDepartamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Departamentos>>
	 */	
	JQGridResponseDto<JerarquiaDto<Departamentos>> jerarquia(Departamentos filterDepartamentos, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the Departamentos table.
	 *
	 * @param filterDepartamentos Departamentos
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Departamentos>>
	 */	
	JQGridResponseDto<JerarquiaDto<Departamentos>> jerarquiaChildren(Departamentos filterDepartamentos, JQGridRequestDto jqGridRequestDto);
    
}


