package com.ejie.ab61.service.procedimientos;


import com.ejie.ab61.model.procedimientos.Direcciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DireccionesService  
 *  
 */

public interface DireccionesService {

	/**
	 * Inserts a single row in the Direcciones table.
	 *
	 * @param direcciones Direcciones
	 * @return Direcciones
	 */
    Direcciones add(Direcciones direcciones);

	/**
	 * Updates a single row in the Direcciones table.
	 *
	 * @param direcciones Direcciones
	 * @return Direcciones
	 */
	Direcciones update(Direcciones direcciones);

	/**
	 * Finds a single row in the Direcciones table.
	 *
	 * @param direcciones Direcciones
	 * @return Direcciones
	 */
	Direcciones find(Direcciones direcciones);

	/**
	 * Deletes a single row in the Direcciones table.
	 *
	 * @param direcciones Direcciones
	 */
	void remove(Direcciones direcciones);

	/**
	 * Finds a list of rows in the Direcciones table.
	 *
	 * @param direcciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<Direcciones>
	 */
	List<Direcciones> findAll(Direcciones direcciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the Direcciones table using like.
	 *
	 * @param direcciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<Direcciones>
	 */
	List<Direcciones> findAllLike(Direcciones direcciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<Direcciones>
	 */	
	JQGridResponseDto<Direcciones> filter(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param searchDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<Direcciones>>
	 */	
    List<TableRowDto<Direcciones>> search(Direcciones filterDirecciones, Direcciones searchDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<Direcciones>>
	 */	
	JQGridResponseDto<JerarquiaDto<Direcciones>> jerarquia(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the Direcciones table.
	 *
	 * @param filterDirecciones Direcciones
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<Direcciones>>
	 */	
	JQGridResponseDto<JerarquiaDto<Direcciones>> jerarquiaChildren(Direcciones filterDirecciones, JQGridRequestDto jqGridRequestDto);
    
}


