package com.ejie.ab61.service.solicitudes;


import com.ejie.ab61.model.solicitudes.MensajesSolicitud;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * MensajesSolicitudService  
 *  
 */

public interface MensajesSolicitudService {

	/**
	 * Inserts a single row in the MensajesSolicitud table.
	 *
	 * @param mensajesSolicitud MensajesSolicitud
	 * @return MensajesSolicitud
	 */
    MensajesSolicitud add(MensajesSolicitud mensajesSolicitud);

	/**
	 * Updates a single row in the MensajesSolicitud table.
	 *
	 * @param mensajesSolicitud MensajesSolicitud
	 * @return MensajesSolicitud
	 */
	MensajesSolicitud update(MensajesSolicitud mensajesSolicitud);

	/**
	 * Finds a single row in the MensajesSolicitud table.
	 *
	 * @param mensajesSolicitud MensajesSolicitud
	 * @return MensajesSolicitud
	 */
	MensajesSolicitud find(MensajesSolicitud mensajesSolicitud);

	/**
	 * Deletes a single row in the MensajesSolicitud table.
	 *
	 * @param mensajesSolicitud MensajesSolicitud
	 */
	void remove(MensajesSolicitud mensajesSolicitud);

	/**
	 * Finds a list of rows in the MensajesSolicitud table.
	 *
	 * @param mensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<MensajesSolicitud>
	 */
	List<MensajesSolicitud> findAll(MensajesSolicitud mensajesSolicitud, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the MensajesSolicitud table using like.
	 *
	 * @param mensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<MensajesSolicitud>
	 */
	List<MensajesSolicitud> findAllLike(MensajesSolicitud mensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<MensajesSolicitud>
	 */	
	JQGridResponseDto<MensajesSolicitud> filter(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param searchMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<MensajesSolicitud>>
	 */	
    List<TableRowDto<MensajesSolicitud>> search(MensajesSolicitud filterMensajesSolicitud, MensajesSolicitud searchMensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<MensajesSolicitud>>
	 */	
	JQGridResponseDto<JerarquiaDto<MensajesSolicitud>> jerarquia(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the MensajesSolicitud table.
	 *
	 * @param filterMensajesSolicitud MensajesSolicitud
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<MensajesSolicitud>>
	 */	
	JQGridResponseDto<JerarquiaDto<MensajesSolicitud>> jerarquiaChildren(MensajesSolicitud filterMensajesSolicitud, JQGridRequestDto jqGridRequestDto);
    
}


