package com.ejie.ab61.service.terceros;

import com.ejie.ab61.model.expedientes.Expedientes;
import com.ejie.ab61.model.terceros.DatosDirecciones;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * DatosDireccionesService  
 * 
 *  
 */

public interface DatosDireccionesService {

	/**
	 * Inserts a single row in the DatosDirecciones table.
	 *
	 * @param datosDirecciones
	 *            DatosDirecciones
	 * @return DatosDirecciones
	 */
	DatosDirecciones add(DatosDirecciones datosDirecciones);

	/**
	 * Updates a single row in the DatosDirecciones table.
	 *
	 * @param datosDirecciones
	 *            DatosDirecciones
	 * @return DatosDirecciones
	 */
	DatosDirecciones update(DatosDirecciones datosDirecciones);

	/**
	 * Finds a single row in the DatosDirecciones table.
	 *
	 * @param datosDirecciones
	 *            DatosDirecciones
	 * @return DatosDirecciones
	 */
	DatosDirecciones find(DatosDirecciones datosDirecciones);

	/**
	 * Deletes a single row in the DatosDirecciones table.
	 *
	 * @param datosDirecciones
	 *            DatosDirecciones
	 */
	void remove(DatosDirecciones datosDirecciones);

	/**
	 * Finds a list of rows in the DatosDirecciones table.
	 *
	 * @param datosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return List<DatosDirecciones>
	 */
	List<DatosDirecciones> findAll(DatosDirecciones datosDirecciones, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the DatosDirecciones table using like.
	 *
	 * @param datosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DatosDirecciones>
	 */
	List<DatosDirecciones> findAllLike(DatosDirecciones datosDirecciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DatosDirecciones table.
	 *
	 * @param filterDatosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(DatosDirecciones filterDatosDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Filter method in the DatosDirecciones table.
	 *
	 * @param filterDatosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<DatosDirecciones>
	 */
	JQGridResponseDto<DatosDirecciones> filter(DatosDirecciones filterDatosDirecciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Searches rows in the DatosDirecciones table.
	 *
	 * @param filterDatosDirecciones
	 *            DatosDirecciones
	 * @param searchDatosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosDirecciones>>
	 */
	List<TableRowDto<DatosDirecciones>> search(DatosDirecciones filterDatosDirecciones,
			DatosDirecciones searchDatosDirecciones, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Reorder the selection made in DatosDirecciones table.
	 *
	 * @param filterDatosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	Object reorderSelection(DatosDirecciones filterDatosDirecciones, JQGridRequestDto jqGridRequestDto,
			Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the DatosDirecciones table.
	 *
	 * @param filterDatosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return JQGridResponseDto<JerarquiaDto<DatosDirecciones>>
	 */
	JQGridResponseDto<JerarquiaDto<DatosDirecciones>> jerarquia(DatosDirecciones filterDatosDirecciones,
			JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/**
	 * Finder method for siblings rows in the hierarchical the DatosDirecciones
	 * table.
	 *
	 * @param filterDatosDirecciones
	 *            DatosDirecciones
	 * @param jqGridRequestDto
	 *            JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<DatosDirecciones>>
	 */
	JQGridResponseDto<JerarquiaDto<DatosDirecciones>> jerarquiaChildren(DatosDirecciones filterDatosDirecciones,
			JQGridRequestDto jqGridRequestDto);

	DatosDirecciones findDireccionByExpediente(Expedientes expediente);

}
