package com.ejie.ab61.service.terceros;


import com.ejie.ab61.model.terceros.TiposCanalAviso;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposCanalAvisoService  
 *  
 */

public interface TiposCanalAvisoService {

	/**
	 * Inserts a single row in the TiposCanalAviso table.
	 *
	 * @param tiposCanalAviso TiposCanalAviso
	 * @return TiposCanalAviso
	 */
    TiposCanalAviso add(TiposCanalAviso tiposCanalAviso);

	/**
	 * Updates a single row in the TiposCanalAviso table.
	 *
	 * @param tiposCanalAviso TiposCanalAviso
	 * @return TiposCanalAviso
	 */
	TiposCanalAviso update(TiposCanalAviso tiposCanalAviso);

	/**
	 * Finds a single row in the TiposCanalAviso table.
	 *
	 * @param tiposCanalAviso TiposCanalAviso
	 * @return TiposCanalAviso
	 */
	TiposCanalAviso find(TiposCanalAviso tiposCanalAviso);

	/**
	 * Deletes a single row in the TiposCanalAviso table.
	 *
	 * @param tiposCanalAviso TiposCanalAviso
	 */
	void remove(TiposCanalAviso tiposCanalAviso);

	/**
	 * Finds a list of rows in the TiposCanalAviso table.
	 *
	 * @param tiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TiposCanalAviso>
	 */
	List<TiposCanalAviso> findAll(TiposCanalAviso tiposCanalAviso, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposCanalAviso table using like.
	 *
	 * @param tiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<TiposCanalAviso>
	 */
	List<TiposCanalAviso> findAllLike(TiposCanalAviso tiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<TiposCanalAviso>
	 */	
	JQGridResponseDto<TiposCanalAviso> filter(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param searchTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposCanalAviso>>
	 */	
    List<TableRowDto<TiposCanalAviso>> search(TiposCanalAviso filterTiposCanalAviso, TiposCanalAviso searchTiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposCanalAviso>>
	 */	
	JQGridResponseDto<JerarquiaDto<TiposCanalAviso>> jerarquia(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the TiposCanalAviso table.
	 *
	 * @param filterTiposCanalAviso TiposCanalAviso
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposCanalAviso>>
	 */	
	JQGridResponseDto<JerarquiaDto<TiposCanalAviso>> jerarquiaChildren(TiposCanalAviso filterTiposCanalAviso, JQGridRequestDto jqGridRequestDto);
    
}


