package com.ejie.ab61.service.terceros;


import com.ejie.ab61.model.terceros.TiposDocumento;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRowDto;
import java.util.List;

/**
 * TiposDocumentoService  
 *  
 */

public interface TiposDocumentoService {

	/**
	 * Inserts a single row in the TiposDocumento table.
	 *
	 * @param tiposDocumento TiposDocumento
	 * @return TiposDocumento
	 */
    TiposDocumento add(TiposDocumento tiposDocumento);

	/**
	 * Updates a single row in the TiposDocumento table.
	 *
	 * @param tiposDocumento TiposDocumento
	 * @return TiposDocumento
	 */
	TiposDocumento update(TiposDocumento tiposDocumento);

	/**
	 * Finds a single row in the TiposDocumento table.
	 *
	 * @param tiposDocumento TiposDocumento
	 * @return TiposDocumento
	 */
	TiposDocumento find(TiposDocumento tiposDocumento);

	/**
	 * Deletes a single row in the TiposDocumento table.
	 *
	 * @param tiposDocumento TiposDocumento
	 */
	void remove(TiposDocumento tiposDocumento);

	/**
	 * Finds a list of rows in the TiposDocumento table.
	 *
	 * @param tiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return List<TiposDocumento>
	 */
	List<TiposDocumento> findAll(TiposDocumento tiposDocumento, JQGridRequestDto jqGridRequestDto);

	/**
	 * Finds rows in the TiposDocumento table using like.
	 *
	 * @param tiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
     * @param startsWith Boolean	 
	 * @return List<TiposDocumento>
	 */
	List<TiposDocumento> findAllLike(TiposDocumento tiposDocumento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TiposDocumento table.
	 *
	 * @param filterTiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 */	
	void removeMultiple(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
   
    
	/**
	 * Filter method in the TiposDocumento table.
	 *
	 * @param filterTiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<TiposDocumento>
	 */	
	JQGridResponseDto<TiposDocumento> filter(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto,  Boolean startsWith);
    
    /**
	 * Searches rows in the TiposDocumento table.
	 *
	 * @param filterTiposDocumento TiposDocumento
	 * @param searchTiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<TiposDocumento>>
	 */	
    List<TableRowDto<TiposDocumento>> search(TiposDocumento filterTiposDocumento, TiposDocumento searchTiposDocumento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /**
	 * Reorder the selection made in TiposDocumento table.
	 *
	 * @param filterTiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    Object reorderSelection(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the TiposDocumento table.
	 *
	 * @param filterTiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @param startsWith Boolean
	 * @return JQGridResponseDto<JerarquiaDto<TiposDocumento>>
	 */	
	JQGridResponseDto<JerarquiaDto<TiposDocumento>> jerarquia(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto, Boolean startsWith);
	
	/**
	 * Finder method for siblings rows in the hierarchical the TiposDocumento table.
	 *
	 * @param filterTiposDocumento TiposDocumento
	 * @param jqGridRequestDto JQGridRequestDto
	 * @return JQGridResponseDto<JerarquiaDto<TiposDocumento>>
	 */	
	JQGridResponseDto<JerarquiaDto<TiposDocumento>> jerarquiaChildren(TiposDocumento filterTiposDocumento, JQGridRequestDto jqGridRequestDto);
    
}


