package com.ejie.ab61.tramita.adapter;

import com.ejie.ab61.model.documento.Documento;

/**
 * PidAdapterService Interfaz del Adaptador con el PID del sistema
 *
 *  
 */
public interface PidAdapterService {

	/**
	 * recuperarDocumento Recupera documento del PID
	 *
	 * @param documento
	 *            Documento
	 * @return Documento
	 */
	public Documento recuperarDocumento(Documento documento);

	/**
	 * insertarDocumento Inserta un documento y devuelve el identificador del
	 * documento en el PID
	 *
	 * @param documento
	 *            Documento
	 * @return String Id del documento insertado
	 */
	public String insertarDocumento(Documento documento);

	/**
	 * modificarDocumento Modifica un documento en el PID
	 *
	 * @param documento
	 *            Documento
	 */
	public void modificarDocumento(Documento documento);

	/**
	 * eliminarDocumento Elimina un documento en el PID
	 *
	 * @param idDocumento
	 *            String
	 */
	public void eliminarDocumento(String idDocumento);
}
