<%@include file="/WEB-INF/includeTemplate.inc"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<section>
	<span id="idExpediente" class="hidden">${expedientes.idExpediente}</span>
	
	<nav class="navbar navbar-default navbar-secundario">
		
		<div class="container">
			<div class="row">
				<div class="pull-left margin-left-15">
					<div class="color-gris"><spring:message code="fexpediente.titulo" /></div>
					<h2>${nombreExpediente}</h2>		
				</div>
			</div>
		</div>
	</nav>
	<div class="container">
		<div id="acordeonExpedientesRelacionados" class="rup_accordion">
			<h1><a><span><spring:message code="expedientesRelacionados" /></span></a></h1>
				<div>
				<!-- TABLA EXPEDIENTES A RELACIONAR (POR UBICACIÓN) -->		
				<div class="panel panel-default">
					<div class="panel-heading"><spring:message code="flistado.buscarExpediente"/></div>
					<div id="tablaExpedientesARelacionarFeedback"></div>
					<div class="panel-body">
						<div id="tablaExpedientesARelacionar_div" class="rup-table-container">
							<div id="tablaExpedientesARelacionar_feedback" class="hidden"></div>
							<div id="tablaExpedientesARelacionar_filter_div" class="rup-table-container">
								<form:form commandName="expedientes" id="tablaExpedientesARelacionar_filter_form"  method="POST">
									<input type="hidden" id="relacionExpediente" name="relacionExpediente" value="${expedientes.relacionExpediente}" />
									<div class="form-group row">
										<div class="col-xs-6">
											<label for="direccionFiltro"><spring:message code="datosDirecciones.direccion" /></label>
											<input type="text" id="direccionFiltro" name="datosDirecciones.direccion" class="form-control" />
										</div>
										<div class="col-xs-2">
											<label for="codPostalFiltro"><spring:message code="datosDirecciones.codPostal" /></label>
											<input type="text" id="codPostalFiltro" name="datosDirecciones.codigoPostal" class="form-control" />
										</div>
										<div class="col-xs-4 text-center">
											<button class="btn btn-default btn-circle" id="btnBuscarExpedientesARelacionar" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="tooltip.buscar" />'><i class="fa fa-search"></i></button>
											<button class="btn btn-default btn-circle" id="btnLimpiarExpedientesARelacionar" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="tooltip.limpiar" />'><i class="fa fa-eraser"></i></button>
										</div>
									</div>
									
									<div class="form-group row">
										<div class="col-xs-4">
											<input type="hidden" id="idProvinciaFiltro" value="${expedientes.datosDirecciones.idProvincia}" />
											<label for="provinciasComboFiltro"><spring:message code="datosDirecciones.provincia" /></label>
											<form:select path="datosDirecciones.idProvincia" id="provinciasComboFiltro" class="form-control combo"></form:select>
										</div>
										<div class="col-xs-4">
											<input type="hidden" id="idMunicipioFiltro" value="${expedientes.datosDirecciones.idMunicipio}" />
											<label for="municipiosComboFiltro"><spring:message code="datosDirecciones.municipio" /></label>
											<form:select path="datosDirecciones.idMunicipio" id="municipiosComboFiltro" class="form-control combo"></form:select>
										</div>
										<div class="col-xs-4">
											<input type="hidden" id="idLocalidadFiltro" value="${expedientes.datosDirecciones.idLocalidad}" />
											<label for="localidadesComboFiltro"><spring:message code="datosDirecciones.localidad" /></label>
											<form:select path="datosDirecciones.idLocalidad" id="localidadesComboFiltro" class="form-control combo"></form:select>
										</div>
									</div>
									
								</form:form>
								
								<div id="tablaExpedientesARelacionar_toolbar" class="mitoolbar clearfix">
									<button id="btnRelacionarExpediente" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="expedientesRelacionados.relacionarExpediente" />'><i class="fa fa-plus" aria-hidden="true"></i></button>
								</div>
															
								<div id="tablaExpedientesARelacionar_grid_div">
									<!-- Tabla -->
									<table id="tablaExpedientesARelacionar" class="table"></table>
									<!-- Barra de paginación -->
									<div id="tablaExpedientesARelacionar_pager"></div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div id="tablaExpedientesARelacionar_filter_toolbar" style="visibility: hidden;"></div>
				
				<!-- TABLA EXPEDIENTES RELACIONADOS -->
				<div class="panel panel-default">
					<div class="panel-heading"><spring:message code="expedientesRelacionados"/></div>
					<div id="tablaExpedientesRelacionadosFeedback"></div>
					<div class="panel-body">
						<div id="tablaExpedientesRelacionados_div" class="rup-table-container">
							<div id="tablaExpedientesRelacionados_feedback" class="hidden"></div>
							<div id="tablaExpedientesRelacionados_filter_div" class="rup-table-container">
								<form:form commandName="expedientes" id="tablaExpedientesRelacionados_filter_form"  method="POST">
									<input type="hidden" id="relacionExpedienteExpedientesRelacionados" name="relacionExpediente" value="${expedientes.relacionExpediente}" />
								</form:form>
							</div>
							<div id="tablaExpedientesRelacionados_toolbar" class="mitoolbar clearfix">
								<button id="btnEliminarRelacionExpediente" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="expedientesRelacionados.eliminarRelacion" />'><i class="fa fa-minus" aria-hidden="true"></i></button>
							</div>
							
							<div id="tablaExpedientesRelacionados_grid_div">
								<!-- Tabla -->
								<table id="tablaExpedientesRelacionados" class="table"></table>
								<!-- Barra de paginación -->
								<div id="tablaExpedientesRelacionados_pager" class="hidden"></div>
							</div>
						</div>
					</div>
				</div>
				<div id="tablaExpedientesRelacionados_filter_toolbar" style="visibility: hidden;"></div>
			</div>
			
			<h1><a><span><spring:message code="inspeccionesRelacionadas.sinExpediente" /></span></a></h1>
			<div>
				<!-- TABLA INSPECCIONES A RELACIONAR (POR UBICACIÓN) -->
				<div class="panel panel-default">
					<div class="panel-heading"><spring:message code="inspeccionesRelacionadas.busqueda"/></div>
					<div id="tablaInspeccionesARelacionarFeedback"></div>
					<div class="panel-body">
						<div id="tablaInspeccionesARelacionar_div" class="rup-table-container">
							<div id="tablaInspeccionesARelacionar_feedback" class="hidden"></div>
							<div id="tablaInspeccionesARelacionar_filter_div" class="rup-table-container">
								<form:form commandName="vTInsSinExpediente" id="tablaInspeccionesARelacionar_filter_form"  method="POST">
									<div class="form-group row">
										<div class="col-xs-6">
											<label for="direccionFiltroInspecciones"><spring:message code="datosDirecciones.direccion" /></label>
											<input type="text" id="direccionFiltroInspecciones" name="direccion" class="form-control" />
										</div>
										<div class="col-xs-2">
											<label for="codPostalFiltroInspecciones"><spring:message code="datosDirecciones.codPostal" /></label>
											<input type="text" id="codPostalFiltroInspecciones" name="codigoPostal" class="form-control" />
										</div>
										<div class="col-xs-4 text-center">
											<button class="btn btn-default btn-circle" id="btnBuscarInspeccionesARelacionar" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="tooltip.buscar" />'><i class="fa fa-search"></i></button>
											<button class="btn btn-default btn-circle" id="btnLimpiarInspeccionesARelacionar" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="tooltip.limpiar" />'><i class="fa fa-eraser"></i></button>
										</div>
									</div>
									
									<div class="form-group row">
										<div class="col-xs-4">
											<input type="hidden" id="idProvinciaFiltroInspecciones" value="${vTInsSinExpediente.idProvincia}" />
											<label for="provinciasComboFiltroInspecciones"><spring:message code="datosDirecciones.provincia" /></label>
											<form:select path="idProvincia" id="provinciasComboFiltroInspecciones" class="form-control combo"></form:select>
										</div>
										<div class="col-xs-4">
											<input type="hidden" id="idMunicipioFiltroInspecciones" value="${vTInsSinExpediente.idMunicipio}" />
											<label for="municipiosComboFiltroInspecciones"><spring:message code="datosDirecciones.municipio" /></label>
											<form:select path="idMunicipio" id="municipiosComboFiltroInspecciones" class="form-control combo"></form:select>
										</div>
										<div class="col-xs-4">
											<input type="hidden" id="idLocalidadFiltroInspecciones" value="${vTInsSinExpediente.idLocalidad}" />
											<label for="localidadesComboFiltroInspecciones"><spring:message code="datosDirecciones.localidad" /></label>
											<form:select path="idLocalidad" id="localidadesComboFiltroInspecciones" class="form-control combo"></form:select>
										</div>
									</div>
									
								</form:form>
								
								<div id="tablaInspeccionesARelacionar_toolbar" class="mitoolbar clearfix">
									<button id="btnRelacionarInspeccion" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="inspeccionesRelacionadas.relacionarInspeccion" />'><i class="fa fa-plus" aria-hidden="true"></i></button>
								</div>
															
								<div id="tablaInspeccionesARelacionar_grid_div">
									<!-- Tabla -->
									<table id="tablaInspeccionesARelacionar" class="table"></table>
									<!-- Barra de paginación -->
									<div id="tablaInspeccionesARelacionar_pager"></div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div id="tablaInspeccionesARelacionar_filter_toolbar" style="visibility: hidden;"></div>
				
				<!-- TABLA INSPECCIONES RELACIONADAS -->
				<div class="panel panel-default">
					<div class="panel-heading"><spring:message code="inspeccionesRelacionadas" /></div>
					<div id="tablaInspeccionesRelacionadasFeedback"></div>
					<div class="panel-body">
						<div id="tablaInspeccionesRelacionadas_div" class="rup-table-container">
							<div id="tablaInspeccionesRelacionadas_feedback" class="hidden"></div>
							
							<div id="tablaInspeccionesRelacionadas_toolbar" class="mitoolbar clearfix">
								<button id="btnEliminarRelacionInspeccion" class="btn btn-default btn-circle" type="button" data-toggle="tooltip" data-placement="top" title='<spring:message code="inspeccionesRelacionadas.eliminarRelacion" />'><i class="fa fa-minus" aria-hidden="true"></i></button>
							</div>
							
							<div id="tablaInspeccionesRelacionadas_grid_div">
								<!-- Tabla -->
								<table id="tablaInspeccionesRelacionadas" class="table"></table>
								<!-- Barra de paginación -->
								<div id="tablaInspeccionesRelacionadas_pager" class="hidden"></div>
							</div>
						</div>
					</div>
				</div>
				<div id="tablaInspeccionesRelacionadas_filter_toolbar" style="visibility: hidden;"></div>
			</div>
		</div>
	</div>
	<div id="space"></div>
</section>